package com.anyway.favor.controller;

import com.anyway.favor.model.FavorItem;
import com.anyway.favor.model.User;
import com.anyway.favor.service.FavorItemService;
import com.anyway.util.PageQuery;
import com.anyway.util.R;
import com.anyway.util.SessionUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.ResponseBody;
import org.springframework.web.servlet.ModelAndView;

import java.util.List;
import java.util.Map;

/**
 * 人情明细控制器
 *
 * @author liuchuanwei
 * @date 2024-02-24
 */
@Controller
@RequestMapping("/favorItem")
public class FavorItemController {
    @Autowired
    private FavorItemService favorItemService;

    /**
     * 跳转列表页面
     *
     * @param mv
     * @return
     */
    @RequestMapping("/toList")
    public ModelAndView toList(ModelAndView mv) {
        mv.setViewName("/favorItem/list");
        return mv;
    }

    /**
     * 人情往来记录列表
     *
     * @param pageQuery
     * @return
     */
    @ResponseBody
    @RequestMapping("/listPage")
    public R listPage(@RequestBody PageQuery<Map<String, Object>> pageQuery) {
        User currentUser = SessionUtils.currentUser();
        Map<String, Object> mapCondition = pageQuery.getTerms();
        //查询和当前登录用户相关的人员
//        mapCondition.put("createBy", currentUser.getId());
        List<FavorItem> favorItemList = favorItemService.findPage(pageQuery);
        return R.page(favorItemList, pageQuery.getPage());
    }
}