package com.anyway.favor.model.dto;

import com.anyway.favor.model.Favor;
import com.anyway.favor.model.FavorItem;
import lombok.Data;
import lombok.NoArgsConstructor;
import org.springframework.beans.BeanUtils;

import java.util.ArrayList;
import java.util.List;

/**
 * 人情新增对象
 *
 * @author liuchuanwei
 * @date 2024-06-29
 */
@NoArgsConstructor
@Data
public class FavorDto extends Favor {

    public FavorDto(Favor favor) {
        BeanUtils.copyProperties(favor, this);
    }

    /** 人情明细 */
    List<FavorItemDto> favorItemList;

    public void initFavorItemList(List<FavorItem> favorItemList) {
        if (this.favorItemList == null) {
            this.favorItemList = new ArrayList<>();
        }
        for (FavorItem favorItem : favorItemList) {
            this.favorItemList.add(new FavorItemDto(favorItem));
        }
    }

    /**
     * 转换为Favor对象
     * @return
     */
    public Favor toFavor() {
        return this;
    }

}
