-- 创建数据库favor
create database favorBill2 default character set utf8mb4 collate utf8mb4_general_ci;
use favorBill2;

drop table if exists t_user;
create table t_user(
    id int(11) primary key auto_increment,
    userName varchar(50) not null comment '账号',
    password varchar(100) not null comment '密码',
    create_time datetime default CURRENT_TIMESTAMP comment '创建时间',
    create_by int(11) comment '创建者',
    modify_time datetime DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP comment '修改时间',
    modify_by int(11) comment '修改者'
) comment '用户表';

drop table if exists t_person;
create table t_person(
    id int(11) primary key auto_increment,
    name varchar(20) comment '姓名',
    phone varchar(20) comment '手机号',
    card_id varchar(20) comment '身份证号',
    call_name varchar(50) comment '称呼',
    gender tinyint(1) comment '性别,1男2女',
    birthday date comment '生日',
    death_date date comment '去世日期',
    marital_status tinyint default 0 comment '婚姻状况，0未婚1已婚',
    mate_id int(11) comment '配偶ID',
    mother_id int(11) comment '母亲ID',
    father_id int(11) comment '父亲ID',
    sort tinyint comment '家中排行',
    tags varchar(255) comment '标签，json格式',
    address varchar(100) comment '详细地址',
    remark varchar(255) comment '备注',
    create_time datetime default CURRENT_TIMESTAMP comment '创建时间',
    create_by int(11) comment '创建者',
    modify_time datetime DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP comment '修改时间',
    modify_by int(11) comment '修改者'
) comment '人员表';
drop table if exists t_favor;
create table t_favor(
    id int(11) primary key auto_increment,
    hold_date date comment '发生日期',
    title varchar(50) comment '标题',
    hold_person_id int(11) comment '举办人ID',
    income_amount decimal(10,2) comment '收入金额',
    pay_amount decimal(10,2) comment '支出金额',
    remark varchar(255) comment '备注',
    create_time datetime default CURRENT_TIMESTAMP comment '创建时间',
    create_by int(11) comment '创建者',
    modify_time datetime DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP comment '修改时间',
    modify_by int(11) comment '修改者'
) comment '事件表';
drop table if exists t_favor_item;
create table t_favor_item(
    id int(11) primary key auto_increment,
    favor_id int(11) comment '事件ID',
    receive_person_id int(11) comment '收礼人ID',
    return_gift_id int(11) comment '回赠礼物ID',
    give_person_id int(11) comment '送礼人ID',
    give_gift_id int(11) comment '赠送礼物ID',
    remark varchar(255) comment '备注',
    create_time datetime default CURRENT_TIMESTAMP comment '创建时间',
    create_by int(11) comment '创建者',
    modify_time datetime DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP comment '修改时间',
    modify_by int(11) comment '修改者'
) comment '人情明细表';

drop table if exists t_gift;
create table t_gift(
    id int(11) primary key auto_increment,
    title varchar(255) comment '礼物名称',
    type char(1) comment '类型，M钱，T物，O其他',
    amount decimal(10,2) comment '价值',
    remark varchar(255) comment '备注',
    create_time datetime default CURRENT_TIMESTAMP comment '创建时间',
    create_by int(11) comment '创建者',
    modify_time datetime DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP comment '修改时间',
    modify_by int(11) comment '修改者'
) comment '礼物表';


-- 插入一条原始数据
insert into t_user(user_name, password) values ('liuchuanwei', '123456');
INSERT INTO t_person (name, card_id, call_name, gender, marital_status, birthday, sort, address)
values ('刘传伟', '371321199301303114', '自己', 'M', 1, '1992-12-29', 1, '刘家河疃');
